﻿/*
created by Michal Hons 2015
miki.hons@gmail.com


*/


try (destroydialog ImgBlurZ) catch()

dgc = dotnetclass "system.gc"
dgc.collect()
gc()
clearlistener()

global ImgBlurZ

global colImg --= openbitmap "F:/MOJE SCRIPTY/img depth/diff.bmp" gamma:1
global depImg --= openbitmap "F:/MOJE SCRIPTY/img depth/depth.bmp" gamma:1

global prewImg

global newImg --= bitmap colImg.width colImg.height color:(random white black) gamma:1

global imgBX2 --= Box2 0 0 colImg.width colImg.height

global imgWidth --= colImg.width
global imgHeight --= colImg.height
global tmST = 0

global blurSize = 6
global inFocus = 0.5
global bucketsCount = 15

global isLive = false

global doneWorkers = 0
global NumWorkers = 4



---- preview codes
fn reduceImg srcImg wi hi =
(
	if gmm == undefined do fp gmm = 2.2
	local tmpBMP = bitmap wi hi color:black gamma:(1.0 / gmm) hdr:false
	for h in 0 to (srcImg.height - 1) by 2 do (
		for w in 0 to (srcImg.width - 1) by 2 do (
			setpixels tmpBMP [(w / 2.0),(h / 2.0 )] (getPixels srcImg [w,h] 1)
		)
	)
	return tmpBMP
)

fn simpleGenPrew srcCImg srcDImg inFocus outImg:undefined =
(
	local tmpImg = bitmap srcCImg.width srcCImg.height hdr:false
	local dp = inFocus --* 0.01
	for h in 0 to (srcCImg.height - 1) do (
		for w in 0 to (srcCImg.width - 1) do (
			local gDP = (getPixels srcDImg [w,h] 1)[1]
			local gCP = (getPixels srcCImg [w,h] 1)[1]
			local sP = case of
			(
				(((1.0 / 255) * (gDp.r)) > (dP + 0.025)):(gDP)
				(((1.0 / 255) * (gDp.r)) < (dP - 0.025)):(gDP)
				default:gCP
			)
			if outImg == undefined then
			(
				setpixels tmpImg [w,h] #(sp)
			)
			else
			(
				setpixels outImg [w,h] #(sp)
			)
		)
	)
	return tmpImg
)

fn genPrewImg cImg dImg inFocus =
(
	if (cImg  != undefined) or (dImg  != undefined) do
	(
		if (classof cImg == BitMap) and (classof dImg == BitMap) do
		(
			if (cImg.width == dImg.width) and (cImg.height == dImg.height) do
			(
				local imgW = floor((cImg.width / 2.0 )+ 0.5)
				
				local imgH =floor((cImg.height / 2.0 )+ 0.5)
				
				if not(imgW < 1) and not(imgH < 1) do
				(
					local tempCImg = reduceImg cImg imgW imgH
					local tempDImg = reduceImg dImg imgW imgH
					
					if prewImg == undefined do
					(
						prewImg = reduceImg cImg imgW imgH
					)
					simpleGenPrew tempCImg tempDImg inFocus outImg:prewImg
				)
			)
		)
	)
)

----main bluring code


fn getBuckets worker imgBX2 dCount =
(
	local Buckets  = #()
	dCount = dCount as integer
	
	local wSize = (imgBX2.w / dCount)
	local lwSize = imgBX2.w - (wSize * dCount)
	
	local hSize = (imgBX2.h / dCount)
	local lhSize = imgBX2.h - (hSize * dCount)
	
	for h in 1 to dCount do
	(
		for w in 1 to dCount do
		(
			local b2a = Box2 [((w - 1) * wSize),((h - 1) * hSize)] [((w * wSize) - 1),((h * hSize) - 1)]
			if (worker == 1) do
			(
				if ((mod w 2) == 1) and ((mod h 2) == 1) do
				(
					append Buckets b2a
				)
			)
			if (worker == 2) do
			(
				if ((mod w 2) == 0) and ((mod h 2) == 0) do
				(
					append Buckets b2a
				)
			)
			if (worker == 3) do
			(
				if ((mod w 2) == 0) and ((mod h 2) == 1) do
				(
					append Buckets b2a
				)
			)
			if (worker == 4) do
			(
				if ((mod w 2) == 1) and ((mod h 2) == 0) do
				(
					append Buckets b2a
				)
			)
		)
	)
	
	if (worker == 1) do
	(
		if (wSize * dCount) < imgBX2.w do
		(
			local b2b = Box2 [(wSize * dCount),0] [(imgBX2.w - 1),((dCount * hSize) - 1)]
			append Buckets b2b
		)
	)
	if (worker == 2) do
	(	
		if (dCount * hSize) < imgBX2.h do
		(
			local b2c = Box2 [0,(dCount * hSize)] [(imgBX2.w - 1),(imgBX2.h - 1)]
			append Buckets b2c
		)
	)
	
	
	return Buckets
)


fn bluringFunction c1 p1 c2 p2 =
(
	local dCol = (getpixels depImg p1 1)[1]
	local depth = (0.003 * dCol.r)
	local bl = (abs (inFocus - depth)) * blurSize
	local bld = 1.0/ bl
	
	local tArr = #()
	local cirq = (pi * bl)
	local nD = 180.0 / cirq
	for i in 0 to cirq do
	(
		local n = (nd * i) - (nd / 2.0)
		
		/*
		local tX = floor(((cos n) * bl) + 0.5)
		local tY = floor(((sin n) * bl) + 0.5)
			*/
		
		
		local tX = ((cos n) * bl) as integer
		local tY = ((sin n) * bl) as integer
		
		
		for a in -tY  to tY do
		(	
			local cY = a
			
			local tD = 1 - (bld * (length [tX,cY]))
				
			local cX = (tX + p1.x - 1)
				
			cY = (a + p1.y - 1)

			if not(cX >= depImg.width) and not(cX < 0) and not(cY >= depImg.width) and not(cY < 0) do
			(
				local nCol = (getpixels depImg [cX,cY] 1)[1]
				local nDepth = (0.003 * nCol.r)
				local nbl = (1 - (abs (depth - ndepth))) * tD
				
				append tArr #([cX,cY],nbl)
			)
		)
	)
	
	makeUniqueArray tArr
		
	local col = black
	
	for i in 1 to tArr.count do
	(
		local sCol = (getpixels colImg tArr[i][1] 1)[1]
		sCol.alpha = 255 * tArr[i][2]
		col += sCol
	)
	
	col = col / (tArr.count as float)
	
	col
)

Fn cSharpWorker1 sender e =
(	
		buckets = getBuckets 1 imgBX2 bucketsCount
		for b in 1 to buckets.count do
		(
			pasteBitmap colImg newImg buckets[b] [(buckets[b].x),(buckets[b].y)] type:#function function:bluringFunction
		)
		
		doneWorkers += 1
		sender.CancelAsync()
		sender.Dispose()
)

Fn cSharpWorker2 sender e =
(	

		buckets = getBuckets 2 imgBX2 bucketsCount
		for b in 1 to buckets.count do
		(
			pasteBitmap colImg newImg buckets[b] [(buckets[b].x),(buckets[b].y)] type:#function function:bluringFunction
		)
		doneWorkers += 1
		sender.CancelAsync()
		sender.Dispose()

)

Fn cSharpWorker3 sender e =
(	

		buckets = getBuckets 3 imgBX2 bucketsCount
		for b in 1 to buckets.count do
		(
			pasteBitmap colImg newImg buckets[b] [(buckets[b].x),(buckets[b].y)] type:#function function:bluringFunction
		)
		doneWorkers += 1
		sender.CancelAsync()
		sender.Dispose()

)

Fn cSharpWorker4 sender e =
(	
		buckets = getBuckets 4 imgBX2 bucketsCount
		for b in 1 to buckets.count do
		(
			pasteBitmap colImg newImg buckets[b] [(buckets[b].x),(buckets[b].y)] type:#function function:bluringFunction
		)
		doneWorkers += 1
		sender.CancelAsync()
		sender.Dispose()

)

fn DoneChecker sender e = 
(
	display newImg
	if (doneWorkers == numWorkers) do
	(
		try (format "done in : %s \n" ((timestamp() - tmST ) / 1000.0)) catch()
		try (sender.stop()) catch()
		try (sender.Dispose()) catch()
	)
)

fn startBluring =
(
	tmST = timestamp()

display newImg


global checkerRenderDot = dotNetObject "System.Windows.Forms.Timer" --create a Timer for img update
dotnet.addEventHandler checkerRenderDot "tick" DoneChecker
checkerRenderDot.interval = 500
checkerRenderDot.start()


global cWorker1 =  dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
cWorker1.WorkerSupportsCancellation = true
dotNet.setLifetimeControl cWorker1 #mxs
dotNet.addEventHandler cWorker1  "DoWork" cSharpWorker1
cWorker1.RunWorkerAsync()

global cWorker2 =  dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
cWorker2.WorkerSupportsCancellation = true
dotNet.setLifetimeControl cWorker2 #mxs
dotNet.addEventHandler cWorker2  "DoWork" cSharpWorker2
cWorker2.RunWorkerAsync()

global cWorker3 =  dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
cWorker3.WorkerSupportsCancellation = true
dotNet.setLifetimeControl cWorker3 #mxs
dotNet.addEventHandler cWorker3  "DoWork" cSharpWorker3
cWorker3.RunWorkerAsync()

global cWorker4 =  dotnetobject "CSharpUtilities.SynchronizingBackgroundWorker"
cWorker4.WorkerSupportsCancellation = true
dotNet.setLifetimeControl cWorker4 #mxs
dotNet.addEventHandler cWorker4  "DoWork" cSharpWorker4
cWorker4.RunWorkerAsync()
)



---rollout not neede, just for kicks
rollout ImgBlurZ "Image Blur"
(
	button srcImgB "Color img" width:128 height:128 align:#center
 	button srcDepthB "Depth img" width:128 height:128 align:#center
	
	group "Settings"
	(
		spinner blurSB "Size:" range:[0,60,10] typer:#integer offset:[0,10]
		spinner inFocusB "In Focus:" range:[0.001,1,0.5] scale:0.001 type:#float
		spinner bucketC "Buckets:" range:[1,50,15] type:#integer
		
		checkbutton LiveB "Preview" checked:false
	)
	
	button applyB "Compute" align:#center offset:[0,10]
	
	
	on LiveB changed state do
	(
		if state == true then
		(
			isLive = true
			genPrewImg  colImg depImg inFocusB.value
			try (display prewImg) catch()
		)
		else
		(
			isLive = false
			try (undisplay prewImg) catch()
		)
	)
	
	on inFocusB entered do
	(
		if isLive do
		(
			genPrewImg  colImg depImg inFocusB.value
			try (display prewImg) catch()
		)
	)
	
		on srcImgB pressed do
	(
		local im = (selectBitMap caption:"Select image")
		if im != undefined do
		(
			colImg = openbitmap ( im.filename)
			newImg =  bitmap colImg.width colImg.height color:(random white black) gamma:1
			 imgWidth = colImg.width
			imgHeight = colImg.height
			imgBX2 = Box2 0 0 colImg.width colImg.height
			clrImg = im
			srcImgB.images = #(clrImg,undefined,1,1,1,1,1)
			imgRez = [clrImg.height, clrImg.width]
		)
	)
	
	on srcDepthB pressed do
	(
		local im = (selectBitMap caption:"Select image")
		if im != undefined do
		(
			depImg =  openbitmap ( im.filename)
			dphImg = im
			srcDepthB.images = #(dphImg,undefined,1,1,1,1,1)
		)
	)
	
	on applyB pressed do
	(
		inFocus = inFocusB.value
		blurSize = blurSB.value
		bucketsCount = bucketC.value
		
		startBluring()
	)
	
)

createdialog ImgBlurZ width:148 style:#(#style_titlebar,#style_sysmenu) --pos:[1000,600]
